Index: /trunk/contactcenter/inc/class.ui_data.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 4838)
+++ /trunk/contactcenter/inc/class.ui_data.inc.php	(revision 5131)
@@ -19,4 +19,5 @@
 		var $public_functions = array(
 			'data_manager' => true,
+                        'advanced_searh_fields' => true 
 		);
 
@@ -68,5 +69,5 @@
 			}
 
-			$this->page_info['actual_catalog'] =& $this->bo->set_catalog($this->page_info['actual_catalog']);
+			$this->page_info['actual_catalog'] = $this->bo->set_catalog($this->page_info['actual_catalog']);
 
 
@@ -257,8 +258,10 @@
 			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_2k_pt', lang('Export as Outlook 2000 (Portuguese) CSV.'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_2k_en', lang('Export as Outlook 2000 (English) CSV.'));
+			$GLOBALS['phpgw']->template->set_var('cc_msg_outlook_2003', lang('Export as Outlook 2003 CSV.'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_expresso_default_csv', lang('Export as Expresso (Default) CSV.'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_copy_to_catalog', lang('Copy to personal catalog.'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_add_contact_to_group', lang('You did not add any contact for this group.'));
 			$GLOBALS['phpgw']->template->set_var('cc_msg_fill_field_name', lang('Fill the field Full Name'));
+			$GLOBALS['phpgw']->template->set_var('cc_msg_show_extra_detail', lang("Show extra contact's details."));
 
 			$select_groups = '';
@@ -282,4 +285,53 @@
 				$GLOBALS['phpgw']->template->set_var('cc_contact_type', 'default');
 			}
+                        
+                        /*
+                         * Monta Contactcenter Busca Avancada
+                         */
+                        $c = CreateObject('phpgwapi.config','contactcenter');
+                        $c->read_repository();
+                        $current_config = $c->config_data;
+
+                        $arraySearch = array();
+                        foreach ($current_config as $index => $value)
+                        {
+
+                            if(substr($index, 0, 24) == 'cc_attribute_searchable_')
+                            {
+                                if($value == 'true')
+                                {
+                                    $v = substr($index, 24, strlen($index));
+                                    $arraySearch[] = $v;
+                                }
+                            }
+                        }
+                        $advanceSearchArray = array();
+                        foreach ($arraySearch as $value)
+                        {
+                            foreach ($current_config as $index => $value2)
+                            {
+                                if($value == substr($index, 22, strlen($index)) && substr($index, 0, 22) == 'cc_attribute_ldapname_')
+                                {
+                                    foreach ($current_config as $index2 => $value3)
+                                    {
+                                        if($value == substr($index2, 18, strlen($index2)) && substr($index2, 0, 18) == 'cc_attribute_name_')
+                                             $advanceSearchArray[$value2] =  $value3;
+                                    }
+                                }
+
+                            }
+                        }
+
+                        $advanceSearch = array();
+                        foreach ($advanceSearchArray as $index => $value)
+                            $advanceSearch[] ='"'.$index.'":"'.$value.'"';
+
+                        $advancedFields =  "{".implode(',',$advanceSearch)."}";
+
+
+                        $GLOBALS['phpgw']->template->set_var('cc_config_advanced_search', $advancedFields);
+
+                        
+                        
 			$GLOBALS['phpgw']->template->parse('out','index');
 
@@ -289,4 +341,5 @@
 			$main .= $api->get_quick_add_plugin();
 			$main .= $api->get_add_group();
+			$main .= $api->get_contact_details();
 			$main .= $GLOBALS['phpgw']->template->get_var('out');
 
@@ -358,5 +411,5 @@
 				case 'get_catalog_add_contact':
 					// To support ldap catalogs with accentuation
-					echo serialize($this->get_catalog_add_contact(utf8_decode($_POST['id'])));
+					echo serialize($this->get_catalog_add_contact($_POST['id']));
 					return;
 
@@ -450,5 +503,6 @@
 					echo $this->get_list_owners_perms_add();
 					return;
-
+				case 'get_contact_details':
+					return $this->get_contact_details($_GET['id']);
 			}
 		}
@@ -487,5 +541,5 @@
 		{
 			$id_catalog = str_replace('\\"', '"', $id_catalog);
-			$temp =& $this->bo->set_catalog($id_catalog);
+			$temp = $this->bo->set_catalog($id_catalog);
 
                         if(!$this->bo->catalog->src_info) {
@@ -505,5 +559,5 @@
 				$this->page_info['changed'] = true;
 				$this->page_info['actual_entries'] = false;
-				$this->page_info['actual_catalog'] =& $temp;
+				$this->page_info['actual_catalog'] = $temp;
 				$this->save_session();
 
@@ -1330,4 +1384,8 @@
 				);
 
+				//verifica se esta habilitado a opcao de exibir os detalhes extras
+				$objconfig = CreateObject('phpgwapi.config', 'contactcenter');
+				$config = $objconfig->read_repository();
+				
 				//echo 'Page: '.$page.'<br>';
 				$n_entries = count($this->page_info['actual_entries']);
@@ -1389,4 +1447,24 @@
 					for($z = 0; $z < $info['count']; $z++) {
 						$owner_names[$info[$z]['uidnumber'][0]] = array("cn" => $info[$z]['cn'][0], "uid" => $info[$z]['uid'][0]);
+					}
+
+					//SAMPLE : dc=teste, dc=diretorio, dc=empresa
+					if(!count($owner_names)){
+						$dns = explode(',', $dn);
+						for($i = count($dns); $i > 0; $i--){
+							$ds = $GLOBALS['phpgw']->common->ldapConnect($this->bo->catalog->src_info['host'], $this->bo->catalog->src_info['acc'], $this->bo->catalog->src_info['pw'], false);
+							//verifica se veio a base como parametro, remoção de erros gerados por paramentro null
+							//if(isset($dns[$i])){
+								$sr = ldap_search($ds,$dns[$i], $filter,$justThese);
+								$info = ldap_get_entries($ds, $sr);
+								ldap_close($ds);
+								for($z = 0; $z < $info['count']; $z++) {
+									$owner_names[$info[$z]['uidnumber'][0]] = array("cn" => $info[$z]['cn'][0], "uid" => $info[$z]['uid'][0]);
+								}	
+								if(count($owner_names)){
+									$i = 0;
+								}
+						//	}
+						}
 					}
 				}
@@ -1418,5 +1496,5 @@
 					);
 
-					$groups =& $this->bo->catalog->get_multiple_entries($ids,$fields);
+					$groups = $this->bo->catalog->get_multiple_entries($ids,$fields);
 
 					$i = 0;
@@ -1473,12 +1551,9 @@
 				if($external)
 				{
-					$contacts = &$this->bo->catalog->get_multiple_entries($ids,$fields,false,true);
+					$contacts = $this->bo->catalog->get_multiple_entries($ids,$fields,false,true);
 				} else{
-					$contacts = &$this->bo->catalog->get_multiple_entries($ids,$fields);
-				}
-
+					$contacts = $this->bo->catalog->get_multiple_entries($ids,$fields);
+				}
 /*******/
-
-
 				if (!is_array($contacts) or !count($contacts))
 				{
@@ -1517,5 +1592,5 @@
 /********/
 
-						$final[3][$i][2] = $contact['companies']['company1']['title']? urldecode( $contact['companies']['company1']['title'] ) :'none';
+						$final[3][$i][2] = $contact['companies']['company1']['title']? $contact['companies']['company1']['title']:'none';
 
 						//Para exibir a matricula do empregado
@@ -1551,5 +1626,8 @@
 										$default_phone_found = true;
 									}
-
+									if($final[3][$i][4] == 'none' or !$final[3][$i][4]){
+										$final[3][$i][4] = "Não informado.";
+										$final[3][$i][13] = $conn_info['id_connection'];
+									}
 /**rev 104**/
 									//if ($_SESSION['phpgw_info']['user']['preferences']['contactcenter']['voip_enabled'] && !$external){
@@ -1563,4 +1641,9 @@
 									$final[3][$i][3] = $conn_info['connection_value'] ? $conn_info['connection_value'] : 'none';
 								}
+								if($final[3][$i][4] == 'none' or !$final[3][$i][4]){
+									$final[3][$i][4] = 'Não informado';
+									$final[3][$i][13] = $conn_info['id_connection'];
+								
+								}
 							}
 						}
@@ -1571,11 +1654,12 @@
 						}
 
-						if (!$final[3][$i][4])
-						{
-							$final[3][$i][4] = 'none';
+						if($final[3][$i][4] == 'none' or !$final[3][$i][4]){
+									$final[3][$i][4] = 'Não informado.';
+									$final[3][$i][13] = $conn_info['id_connection'];
+								
 						}
 
 						$final[3][$i][5] = $contact['alias']? urldecode( $contact['alias'] ):'none';
-						$final[3][$i][6] = $ids[$i];
+						$final[3][$i][6] = utf8_decode($ids[$i]);
 
 /**rev 104**/
@@ -1593,7 +1677,9 @@
 							$final[3][$i][12] = lang('Shared').": ".$owner_names[$owners[$i]]['cn'];
 						}
-/******/
 
 						$final[4][$i] = $contact['photo'] ? 1  : 0;
+						
+
+
 						$i++;
 					}
@@ -1610,6 +1696,6 @@
 				$final[9] = $count;
                                 $final[11] = $this->bo->catalog_level;
-
-
+				$final[12] = isset($config['cc_allow_details'])? $config['cc_allow_details'] : false;
+				$final[13] = '<span class="" ';
 				$this->page_info['actual_letter'] = $letter;
 				$this->page_info['actual_page'] = $page;
@@ -1656,4 +1742,19 @@
 				}
 				ldap_close($ds);
+				if(!count($owner_names)){
+						$dns = explode(',', $dn);
+						for($i = count($dns); $i > 0; $i--){
+							$ds = $GLOBALS['phpgw']->common->ldapConnect($this->bo->catalog->src_info['host'], $this->bo->catalog->src_info['acc'], $this->bo->catalog->src_info['pw'], false);
+							$sr = ldap_search($ds,$dns[$i], $filter,$justThese);
+							$info = ldap_get_entries($ds, $sr);
+							ldap_close($ds);
+							for($z = 0; $z < $info['count']; $z++) {
+								$owner_names[$info[$z]['uidnumber'][0]] = array("cn" => $info[$z]['cn'][0], "uid" => $info[$z]['uid'][0]);
+							}
+							if(count($owner_names)){
+								$i = 0;
+							}
+						}
+					}
 			}
 			echo serialize ($owner_names);	
@@ -1690,10 +1791,14 @@
 			$boGroup = CreateObject('contactcenter.bo_group');
 
-			$all_contacts = $boGroup->get_all_contacts('only_email',$shared_from);
+			$all_contacts = $boGroup->get_all_contacts(false,$shared_from);
 			
 			$contact_options = "";
 			if(count($all_contacts)) {					
 				foreach($all_contacts as $idx => $contact) {				
-					$contact_options .= "<OPTION value='".$contact['id_connection']."'>".$contact['names_ordered']." (".$contact['connection_value'].")</OPTION>";
+					$contact_options .= "<OPTION value='".$contact['id_connection']."'>".$contact['names_ordered'];
+					if (isset($contact['connection_value']))
+						$contact_options .= " (".$contact['connection_value'].")</OPTION>";
+					else
+						$contact_options .= " (". $contact['phone'].")</OPTION>";
 				}
 			}
@@ -1805,4 +1910,30 @@
 
 			/* Relations */
+                        /* Groups */
+			/*
+			 * Criado uma estrutura no data que conterá os grupos do
+			 * contato. O formato é:
+			 * data['groups'] = array(
+			 * 						'id_group' => array(
+			 * 										'id_group', 'title', 'short_name'
+			 * 										)
+			 * 						);
+			 */
+			$boGroup = CreateObject('contactcenter.bo_group');
+			$groups = $boGroup->get_contact_groups($id);
+			
+			$i = 0;
+			$data['groups'] = array();
+			if(is_array($groups))
+			foreach($groups as $group)
+			{
+				$idGroup = $group['id_group'];
+				$data['groups'][$idGroup] = array(
+					'title' 		=> $group['title'],
+					'id_group' 		=> $idGroup,
+					'short_name' 	=> $group['short_name']
+				);
+				$i++;
+			}
 
 			echo serialize($data);
@@ -1824,6 +1955,20 @@
 			$predata[] = $boPeopleCatalog -> get_all_countries();
 			$predata[] = $boPeopleCatalog -> get_all_connections_types();
+			$boGroup = CreateObject('contactcenter.bo_group'); 
+            //$predata[] = $boGroup->get_groups_by_user();
 			//$predata[] = $this->bo->catalog->get_all_relations_types();
 
+			if ($this->typeContact == 'shared_contacts') {  
+ 		                                $so_contact = CreateObject('contactcenter.so_contact',  $GLOBALS['phpgw_info']['user']['account_id']); 
+ 		                $relacionados = $so_contact->get_relations(); 
+ 		                         
+ 		                foreach($relacionados as $uid_relacionado => $tipo_relacionamento) {     
+ 	                                        $predata[] = $boGroup->get_groups_by_user($uid_relacionado);                                             
+ 		                                }        
+ 		                        } else { 
+ 		                                                $predata[] = $boGroup->get_groups_by_user(); 
+ 		                                        }
+			
+			
 			$i = 0;
 			foreach($predata as $data_)
@@ -1883,32 +2028,4 @@
                                 }
 			}
-
-			// verifica se email já existe!
-			$boGroup = CreateObject('contactcenter.bo_group');
-			$contact = $boGroup->verify_contact($tdata[4]);
-
-			if($contact)
-			{
-				$str_contact = "\r\n - ".implode("\r\n - ",$contact);
-
-                            if ($echo)
-                            {
-				echo serialize(array(
-					'msg'    => lang('Problems on adding your Contact. The email "%1" already exists in: %2',$tdata[4], $str_contact),
-					'status' => 'alreadyExists'
-				));
-
-				return;
-                            }
-                            else
-                                {
-                                    return serialize(array(
-					'msg'       => lang('Problems on adding your Contact. The email "%1" already exists in: %2',$tdata[4], $str_contact),
-					'status'    => 'alreadyExists',
-                                        'id_connection'  => $contact[1]
-                                    ));
-                                }
-			}
-
 			$data['alias'] = addslashes($tdata[0]);
 			$data['given_names'] = addslashes($tdata[1]);
@@ -2305,16 +2422,4 @@
 					$email = $dataConn['connection'.$i]['connection_value'];
 				    }
-				}
-				// verifica se email já existe!
-				$boGroup = CreateObject('contactcenter.bo_group');
-				$contact = $boGroup->verify_contact($email);
-				if($contact)
-				{
-				    $str_contact = "\r\n - ".implode("\r\n - ",$contact);
-				    echo serialize(array(
-				    'msg'    => lang('Problems on adding your Contact. The email "%1" already exists in: %2',$tdata[4], $str_contact),
-				    'status' => 'alreadyExists'
-				    ));
-				    return;
 				}
 
@@ -2448,5 +2553,8 @@
 						/* Does nothing... */
 						break;
-
+					case 'groups':
+						$groups = $data['groups'];
+						unset($data['groups']);
+						break;
 					default:
 						echo serialize(array(
@@ -2482,4 +2590,11 @@
 					'status' => 'fail'
 				);
+			}
+                        else
+			{
+				if (isset($old_connections))
+					$this->bo->catalog->update_contact_groups($id, $groups, $old_connections);
+				else
+					$this->bo->catalog->update_contact_groups($id, $groups);
 			}
 
@@ -2617,16 +2732,4 @@
 					$email = $dataConn['connection'.$i]['connection_value'];
 				    }
-				}
-				// verifica se email já existe!
-				$boGroup = CreateObject('contactcenter.bo_group');
-				$contact = $boGroup->verify_shared_contact($owner,$email);
-				if($contact)
-				{
-				    $str_contact = "\r\n - ".implode("\r\n - ",$contact);
-				    echo serialize(array(
-				    'msg'    => lang('Problems on adding your Contact. The email "%1" already exists in: %2',$tdata[4], $str_contact),
-				    'status' => 'alreadyExists'
-				    ));
-				    return;
 				}
 
@@ -2765,27 +2868,29 @@
 			}
 
-			$code = '$id = $this->bo->catalog->';
+			//$code = '$id = $this->bo->catalog->';
 
 			if (!is_null($id) and $id !== '')
 			{
-				$code .= $code.'update_single_info($id, $data);';
+				//$code .= $code.'update_single_info($id, $data);';
+				$id = $this->bo->catalog->update_single_info($id, $data);
+				if(!$id){
 				$result = array(
-					'msg' => lang('Updated Successfully!'),
+						'msg' => lang('Some problem occured when trying to insert/update contact information.<br>'.
+				        'Report the problem to the Administrator.'),
+						'status' => 'fail'
+				);
+			}
+				else{
+				$result = array(
+						'msg' => lang('Updated Successfully!'),
 					'status' => 'ok'
 				);
 			}
+			}
 			else
 			{
-				$code .= 'add_single_entry($data,'.$owner.');';
-				$result = array(
-					'msg' => lang('Entry Added Successfully!'),
-					'status' => 'ok'
-				);
-			}
-
-			eval($code);
-
-			if (!($id))
-			{
+				//$code .= 'add_single_entry($data,'.$owner.');';
+				$id = $this->bo->catalog->add_single_entry($data,$owner);
+				if(!$id){
 				$result = array(
 					'msg' => lang('Some problem occured when trying to insert/update contact information.<br>'.
@@ -2794,7 +2899,13 @@
 				);
 			}
-
+				else{
+					$result = array(
+						'msg' => lang('Entry Added Successfully!'),
+						'status' => 'ok'
+					);
+				}
+			}
 			echo serialize($result);
-}
+		}
 		/*!
 
@@ -3096,10 +3207,17 @@
 			if (!is_array($data) || (!$data['search_for'] && !$full_search) || !is_array($data['fields']))
 			{
-				echo serialize(array(
-					'msg'    => lang('Invalid parameters'),
-					'status' => 'abort'
-				));
-
-				return array('error' => lang('Invalid parameters'));
+			//	echo serialize(array(
+			//		'msg'    => lang('Invalid parameters'),
+			//		'status' => 'abort'
+			//	));
+
+			//	return array('error' => lang('Invalid parameters'));
+				$rules = array(
+					0 => array(
+						'field' => $data['fields']['search'],
+						'type'  => 'LIKE',
+						'value' => '%'
+					)
+				);
 			}
 
@@ -3118,5 +3236,5 @@
 			{
 
-				$data['search_for'] = utf8_encode($data['search_for']);
+				$data['search_for'] = $data['search_for'];
 			}
 
@@ -3245,6 +3363,5 @@
 				// Get only this attributes: dn, cn for external catalogs,
 				// used to restrict the attributes used in filters
-				$ids = $this->bo->find(array($data['fields']['id'], $data['fields']['search']), $rules, array('order' => $data['fields']['search'], 'sort' => 'ASC'), $data['search_for'] != null);
-			}
+				$ids = $this->bo->find(array($data['fields']['id'], $data['fields']['search']), $rules, array('order' => $data['fields']['search'], 'sort' => 'ASC', 'customFilter' => $data['custom_filter'], 'CN' => $data['CN'], 'exact' => $data['exact']), $data['search_for'] != null);	}
 			else
 			{
@@ -3259,6 +3376,5 @@
 					'contact.connection.mail',
 					'contact.connection.phone'
-					), $rules, array('order' => $data['fields']['search'], 'sort' => 'ASC'), $data['search_for_area'], $data['search_for'] != null );
-			}
+					), $rules, array('order' => $data['fields']['search'], 'sort' => 'ASC', 'customFilter' => $data['custom_filter'], 'CN' => $data['CN'], 'exact' => $data['exact']), $data['search_for_area'], $data['search_for'] != null ); }
 
 			if (!is_array($ids) || !count($ids))
@@ -3641,4 +3757,5 @@
 			for($z = 0; $z < 5; $z++) {
 				$participant = $info[0][$justThese[$z]];
+				$participant[0] = utf8_decode($participant[0]);
 				array_push($array_participants, $participant);
 			}
@@ -3755,4 +3872,5 @@
 			$contacts = $boGroup->get_all_contacts();
 			$streamBuffer = '';
+			$stramArray = Array();
 
 			if(!count($contacts))
@@ -3780,5 +3898,5 @@
 
 				case 'outlook_pt-BR':
-					$streamBuffer = "Nome;Sobrenome;Segundo nome;Nome;Apelido;End. de email;Endereço residencial;"
+					$streamBuffer = "Nome;Apelido;End. de email;Endereço residencial;"
 									."Cidade do endereço residencial;CEP do endereço residencial;Estado;País/região do endereço residencial;"
 									."Telefone residencial;Fax residencial;Telefone celular;Página pessoal da Web;Rua do endereço comercial;"
@@ -3789,5 +3907,4 @@
 					foreach($contacts as $index => $object){
 						$streamBuffer.= "\"".$object[ 'names_ordered'] . "\";"
-							.";;;"
 							. "\"".$object[ 'alias' ] . "\";"
 							. "\"".$object[ 'main-mail' ] . "\";"
@@ -3813,5 +3930,5 @@
 							. "\"".$object[ 'job_title' ] . "\";"
 							. "\"".$object[ 'department' ] . "\";"
-							.";"
+							."\"\";"
 							. "\"".str_replace("\r\n\x0a","\t",$object[ 'notes' ]) . "\"\r\n";
 					}
@@ -3958,42 +4075,58 @@
 						."Home Address 2,Home City,Home State,Home ZipCode,Home Country,Work Address,Work Address 2,"
 						."Work City,Work State,Work ZipCode,Work Country,Job Title,Department,Organization,Web Page 1,"
-						."Web Page 2,Birth Year,Birth Month,Birth Day,Custom 1,Custom 2,Custom 3,Custom 4,Notes,\n";
+						."Web Page 2,Birth Year,Birth Month,Birth Day,Custom 1,Custom 2,Custom 3,Custom 4,Notes,\r\n";
 
 					foreach($contacts as $index => $object){
 						$array_birth = explode("-",$object[ 'birthdate' ]);
-						$streamBuffer.= "\"".$object[ 'names_ordered'] . "\","
-							.",,"
-							. "\"".$object[ 'alias' ] . "\","
-							. "\"".$object[ 'main-mail' ] . "\","
-							. "\"".$object[ 'alternative-mail' ] . "\","
-							.","
-                                                        . "\"".$phone . "\","
-							. "\"".$object[ 'home-phone' ] . "\","
-							. "\"".$object[ 'business-fax' ] . "\","
-							. "\"".$object[ 'business-pager' ] . "\","
-							. "\"".$object[ 'mobile' ] . "\","
-							. "\"".$object[ 'home-address' ] . "\","
-							. "\"".$object[ 'home-address-2' ] . "\","
-							. "\"".$object[ 'home-city_name' ] . "\","
-							. "\"".$object[ 'home-state_name' ] . "\","
-							. "\"".$object[ 'home-postal_code' ] . "\","
-							. "\"".$object[ 'home-id_country' ] . "\","
-							. "\"".$object[ 'business-address' ] . "\","
-							. "\"".$object[ 'business-address-2' ] . "\","
-							. "\"".$object[ 'business-city_name' ] . "\","
-							. "\"".$object[ 'business-state_name' ] . "\","
-							. "\"".$object[ 'business-postal_code' ] . "\","
-							. "\"".$object[ 'business-id_country' ] . "\","
-							. "\"".$object[ 'job_title' ] . "\","
-							. "\"".$object[ 'department' ] . "\","
-							. "\"".$object[ 'corporate_name' ] . "\","
-							. "\"".$object[ 'web_page' ] . "\","
-							. "\"".$object[ 'web_page' ] . "\","
-							. "\"".$array_birth[0] . "\","
-							. "\"".$array_birth[1] . "\","
-							. "\"".$array_birth[2] . "\","
-							.",,,,"
-							. "\"".str_replace("\r\n\x0a","\t",$object[ 'notes' ]) . "\",\r\n";
-
+
+						$stramArray[0] = "\"".$object[ 'names_ordered'] . "\"";
+						$stramArray[1] = "";
+						$stramArray[2] = "\"".$object[ 'names_ordered'] . "\"";
+						$stramArray[3] = "\"".$object[ 'alias' ] . "\"";
+						$stramArray[4] = "\"".$object[ 'main-mail' ] . "\"";
+						$stramArray[5] = "\"".$object[ 'alternative-mail' ] . "\"";
+						$stramArray[6] = "";
+						$stramArray[7] = "\"".$object[ 'business-phone' ] . "\"";
+						$stramArray[8] = "\"".$object[ 'home-phone' ] . "\"";
+						$stramArray[9] = "\"".$object[ 'business-fax' ] . "\"";
+						$stramArray[10] = "\"".$object[ 'business-pager' ] . "\"";
+						$stramArray[11] = "\"".$object[ 'mobile' ] . "\"";
+						$stramArray[12] = "\"".$object[ 'home-address' ] . "\"";
+						$stramArray[13] = "\"".$object[ 'home-address-2' ] . "\"";
+						$stramArray[14] = "\"".$object[ 'home-city_name' ] . "\"";
+						$stramArray[15] = "\"".$object[ 'home-state_name' ] . "\"";
+						$stramArray[16] = "\"".$object[ 'home-postal_code' ] . "\"";
+						$stramArray[17] = "\"".$object[ 'home-id_country' ] . "\"";
+						$stramArray[18] = "\"".$object[ 'business-address' ] . "\"";
+						$stramArray[19] = "\"".$object[ 'business-address-2' ] . "\"";
+						$stramArray[20] = "\"".$object[ 'business-city_name' ] . "\"";
+						$stramArray[21] = "\"".$object[ 'business-state_name' ] . "\"";
+						$stramArray[22] = "\"".$object[ 'business-postal_code' ] . "\"";
+						$stramArray[23] = "\"".$object[ 'business-id_country' ] . "\"";
+						$stramArray[24] = "\"".$object[ 'job_title' ] . "\"";
+						$stramArray[25] = "\"".$object[ 'department' ] . "\"";
+						$stramArray[26] = "\"".$object[ 'corporate_name' ] . "\"";
+						$stramArray[27] = "";
+						$stramArray[28] = "";
+						$stramArray[29] = "\"".$array_birth[0] . "\"";
+						$stramArray[30] = "\"".$array_birth[1] . "\"";
+						$stramArray[31] = "\"".$array_birth[2] . "\"";
+						$stramArray[32] = "";
+						$stramArray[33] = "";
+						$stramArray[34] = "";
+						$stramArray[35] = "";
+						$stramArray[36] = "";
+						$stramArray[37] = "\"".str_replace("\r\n\x0a","\t",$object[ 'notes' ]) . "\"\r\n";
+						
+						if($object[ 'phone' ]){
+							if(!$object[ 'home-phone' ])
+								$stramArray[8] = "\"".$object[ 'phone' ]. "\"";
+							else if(!$object[ 'mobile' ])
+								$stramArray[11] = "\"".$object[ 'phone' ]. "\"";
+							else if(!$object[ 'business-phone' ])
+								$stramArray[7] = "\"".$object[ 'phone' ]. "\"";
+						}
+						
+						$streamBuffer .= implode("," , $stramArray);
 					}
 				break;
